# Copyright 2009-2016 Canonical Ltd.  This software is licensed under the
# GNU Affero General Public License version 3 (see the file LICENSE).

from urllib import urlopen

from testtools import TestCase

from gpgservice.config import config
from gpgservice.testing.keyserver import KeyServerTac
from gpgservice.testing.keyserver.web import GREETING

__metaclass__ = type


class TestKeyServerTac(TestCase):

    @property
    def daemon_port(self):
        return config.getint('gpghandler', 'port')

    def test_url(self):
        # The url is the one that gpghandler is configured to hit.
        fixture = KeyServerTac()
        self.assertEqual(
            'http://%s:%d' % (
                config.get('gpghandler', 'host'),
                config.getint('gpghandler', 'port')),
            fixture.url)

    def test_starts_properly(self):
        # Make sure the tac starts properly and that we can load the page.
        fixture = KeyServerTac()
        fixture.setUp()
        self.addCleanup(fixture.tearDown)
        content = urlopen(fixture.url).readline()
        self.assertEqual(GREETING, content)


def test_suite():
    from unittest import TestLoader
    return TestLoader().loadTestsFromName(__name__)
